package com.bocloud.ims.repository.resource;

import java.util.Date;
import java.util.List;
import java.util.Map;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import com.bocloud.common.model.Pager;
import com.bocloud.common.model.Param;
import com.bocloud.common.utils.Common;
import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.database.utils.QueryBuilder;
import com.bocloud.ims.entity.resource.LbListenerPolicy;

/**
 * 负载均衡器-监听器-转发策略Repository实现
 *
 * @author majiali
 * @version 1.0
 * @since 2021年1月19日
 */
@Repository("lbListenerPolicyRepository")
public class LbListenerPolicyRepository extends BasicGenericDao<LbListenerPolicy, Long> {

	public LbListenerPolicyRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
		super(jdbcTemplate, npJdbcTemplate);
	}

	public List<LbListenerPolicy> list(int page, int rows, List<Param> params, Map<String, String> sorter)
			throws Exception {
		String sql = "select a.* from lb_listener_policy a  where a.is_deleted = 0";
		sql = QueryBuilder.buildRaw(sql, new Pager(page, rows, params, sorter), "a");
		Map<String, Object> paramMap = QueryBuilder.getParam(params);
		return this.list(LbListenerPolicy.class, sql, paramMap);
	}

	public List<LbListenerPolicy> listByVid(Long vendorId) throws Exception {
		String sql = "select a.* from lb_listener_policy a  where a.is_deleted = 0 and a.vendor_id = :vendorId";
		Map<String, Object> params = MapTools.simpleMap(Common.VENDORID, vendorId);
		return this.list(LbListenerPolicy.class, sql, params);
	}

	public int count(List<Param> params) throws Exception {
		String sql = "select count(1) from lb_listener_policy a where a.is_deleted = 0";
		sql = QueryBuilder.buildRaw(sql, params, null, "a");
		Map<String, Object> paramMap = QueryBuilder.getParam(params);
		return this.countQuery(sql, paramMap).intValue();
	}

	public boolean remove(Long id, Long userId) throws Exception {
		String sql = "update lb_listener_policy set is_deleted = true,gmt_modify = :gmtModify,mender_id = :menderId where is_deleted = 0 and id = :id";
		Map<String, Object> params = MapTools.simpleMap("id", id);
		params.put("menderId", userId);
		params.put("gmtModify", new Date());
		return this.execute(sql, params) > 0;
	}

	public boolean removeByVid(Long vendorId, Long userId) throws Exception {
		String sql = "update lb_listener_policy set is_deleted = true,gmt_modify = :gmtModify,mender_id = :menderId where is_deleted = 0 and vendor_id = :vendorId";
		Map<String, Object> params = MapTools.simpleMap(Common.VENDORID, vendorId);
		params.put("menderId", userId);
		params.put("gmtModify", new Date());
		return this.execute(sql, params) > 0;
	}

	public LbListenerPolicy query(Long id) throws Exception {
		String sql = "select a.* from lb_listener_policy a  where a.is_deleted = 0 and a.id = :id";
		Map<String, Object> params = MapTools.simpleMap(Common.ID, id);
		List<LbListenerPolicy> list = this.list(LbListenerPolicy.class, sql, params);
		if (list.isEmpty()) {
			return null;
		}
		return list.get(0);
	}

	public LbListenerPolicy queryByUuid(String policyUuid) throws Exception {
		String sql = "select a.* from lb_listener_policy a  where a.is_deleted = 0 and a.policy_uuid = :policyUuid";
		Map<String, Object> params = MapTools.simpleMap("policyUuid", policyUuid);
		List<LbListenerPolicy> list = this.list(LbListenerPolicy.class, sql, params);
		if (list.isEmpty()) {
			return null;
		}
		return list.get(0);
	}

	public boolean removeByVid(Long vendorId, Long userId, String regionId) throws Exception {
		String sql = "update lb_listener_policy set is_deleted = true,gmt_modify = :gmtModify,mender_id = :menderId where is_deleted = 0  and region_id = :regionId and vendor_id = :vendorId";
		Map<String, Object> params = MapTools.simpleMap("vendorId", vendorId);
		params.put("menderId", userId);
		params.put("gmtModify", new Date());
		params.put("regionId", regionId);
		return this.execute(sql, params) > 0;
	}

	public List<LbListenerPolicy> listByVid(Long vendorId, String regionId) throws Exception {
		String sql = "select a.* from lb_listener_policy a where a.is_deleted = 0 and a.vendor_id = :vendorId and a.region_id = :regionId ";
		Map<String, Object> params = MapTools.simpleMap("vendorId", vendorId);
		params.put("regionId", regionId);
		return this.list(LbListenerPolicy.class, sql, params);
	}

}
